rng default;

carrierfreq=1400;
symbolrate=125;
bitspersymbol=1;
Fs=8000;

bitpersymbol=1;
fb=symbolrate*bitpersymbol;

close all;

%init varicode
varicode_init;

trellis = struct('numInputSymbols',2,'numOutputSymbols',2,'numStates',4,...
    'nextStates',[1 3; 0 2; 1 3; 0 2],'outputs',[1 0; 0 1; 0 1; 1 0]);

numberofsymbolstoxferpercycle=16;%make this even and about 1/4 of symbolrate seems ok

SamplesPerSymbol=(Fs/symbolrate);
ModulationOrder=2^bitspersymbol;
hModulator = comm.CPFSKModulator(ModulationOrder, 'BitInput', true,'SymbolMapping', 'Gray');
hModulator.ModulationIndex=0.5;
hModulator.SamplesPerSymbol=SamplesPerSymbol;

DELAYsig = dsp.VariableIntegerDelay;
DELAYsig.MaximumDelay=SamplesPerSymbol*6;

SymbolTimingDelay = dsp.VariableIntegerDelay;
SymbolTimingDelay.MaximumDelay=SamplesPerSymbol*2;

hsinwave = dsp.SineWave('Frequency', symbolrate/4,'SampleRate',Fs,'SamplesPerFrame',SamplesPerSymbol*2,'ComplexOutput',false);
ct = abs(hsinwave.step());
ct=ct/(numel(ct));
MatchFir = dsp.FIRFilter('Numerator',ct');
MatchFir2 = dsp.FIRFilter('Numerator',ct');

har = dsp.AudioRecorder('SampleRate',Fs);
har.NumChannels=1;
har.SamplesPerFrame=numberofsymbolstoxferpercycle*SamplesPerSymbol;

hap = dsp.AudioPlayer('SampleRate',Fs);


N   = 200;        % FIR filter order
Fp  = 400;%symbolrate*2;% passband-edge frequency
Rp  = 0.00057565; % Corresponds to 0.01 dB peak-to-peak ripple
Rst = 1e-4;       % Corresponds to 80 dB stopband attenuation
NUM = firceqrip(N,Fp/(Fs/2),[Rp Rst],'passedge'); % NUM = vector of coeffs
LP_FIR = dsp.FIRFilter('Numerator',NUM); % Or use NUM200 or NUM_MIN
%fvtool(LP_FIR,'Fs',Fs,'Color','White')

AGCSecondsToAveOver=4;
AGCSymbolsToAveOver=symbolrate*AGCSecondsToAveOver;
AGCMASz=round(AGCSymbolsToAveOver/numberofsymbolstoxferpercycle);
AGCMASum=0;
AGCMABuffer=zeros(AGCMASz,1);
AGCMAPtr=1;
AGCVal=0;
AGCAmp=1;

hConstellationScopeCarrierPhase = comm.ConstellationDiagram();%('XLimits',[-1.5 1.5],'YLimits',[-1.5 1.5]);
hConstellationScopeCarrierPhase.ReferenceConstellation=[-1+1i,1+1i,-1-1i,1-1i];
hConstellationScopeCarrierPhase.SymbolsToDisplaySource='Property';
hConstellationScopeCarrierPhase.SymbolsToDisplay=10;
hConstellationScopeCarrierPhase.ShowReferenceConstellation=true;
hConstellationScopeCarrierPhase.Name='Carrier Phase';
hConstellationScopeCarrierPhase.show;

hConstellationScopeSymbolPhase = comm.ConstellationDiagram();%('XLimits',[-1.5 1.5],'YLimits',[-1.5 1.5]);
hConstellationScopeSymbolPhase.ReferenceConstellation=[-1+1i,1+1i,-1-1i,1-1i];
hConstellationScopeSymbolPhase.SymbolsToDisplaySource='Property';
hConstellationScopeSymbolPhase.SymbolsToDisplay=10;
hConstellationScopeSymbolPhase.ShowReferenceConstellation=true;
hConstellationScopeSymbolPhase.Name='Symbol Phase';
hConstellationScopeSymbolPhase.show;

hConstellationScopePoints = comm.ConstellationDiagram();%('XLimits',[-1.5 1.5],'YLimits',[-1.5 1.5]);
hConstellationScopePoints.ReferenceConstellation=[-1+1i,1+1i,-1-1i,1-1i];
hConstellationScopePoints.SymbolsToDisplaySource='Property';
hConstellationScopePoints.SymbolsToDisplay=500;
hConstellationScopePoints.ShowReferenceConstellation=true;
hConstellationScopePoints.Name='Constellation';
hConstellationScopePoints.show;

scope = dsp.TimeScope('SampleRate', symbolrate/2,'TimeSpan', 30,'Name','Symbol phase','YLabel','Symbol timging error function');%Phase (samples)');

hPFOu = comm.PhaseFrequencyOffset('FrequencyOffset', carrierfreq,'SampleRate',Fs);
hPFOd = comm.PhaseFrequencyOffset('FrequencyOffset', -carrierfreq,'SampleRate',Fs);
hPFOu.PhaseOffset=22.45*1;

hSymTracker= struct('Freq',0,'Phase',0);

hConEnc = comm.ConvolutionalEncoder('TrellisStructure',trellis,'TerminationMethod','Continuous');

%diff decoder
hdiffdec = comm.DifferentialDecoder;

hbuff=dsp.Buffer(numberofsymbolstoxferpercycle*SamplesPerSymbol+2*SamplesPerSymbol,2*SamplesPerSymbol);%allow 2*SamplesPerSymbol samples from previous buffer so we have -ve indicies

lastindex=1;

%x=randi([0 1],1000,1);

%create message
message=[];
for kk=1:500;%100
    message=sprintf('%s   .. OK???? %d This is a longer message as things are sent little by little...     \n',message,kk);
end

%vari encode it
data_org=vari_encode(message);

% data_org=[ 0 1 1 0 1 1 0 0 0 0 0 0 0 0 0 0 0 0]';
% for kk=1:12
%     data_org=[data_org;data_org];
% end

data_org=[data_org;zeros(32,1)];%some idle bits;
databitarray=buffer(data_org,1*numberofsymbolstoxferpercycle);

fftbufferperiod=3;%seconds
fftbufferblkcnt=round(fftbufferperiod*symbolrate/numberofsymbolstoxferpercycle);
fftbuffer=zeros(numberofsymbolstoxferpercycle*SamplesPerSymbol*fftbufferblkcnt,1);
fftbufferblkptr=0;

MaxFreqDeviationLock=500;%Hz

EbNo=120;
symbolrateimpairment=0;%wont last forever


for i=1:size(databitarray,2);
    
    %mod
%     data=hConEnc.step(hdiffenc.step(databitarray(:,i)));%for non dif transmission
    data=(databitarray(:,i));
    y=hModulator.step(data);
    
    %%%symbol timing impairment
    y=DELAYsig.step(y,symbolrateimpairment);
    symbolrateimpairment=symbolrateimpairment+0.2;
    %%%

    %up
    y=real(hPFOu.step(y)/4);
    
    %%%noise impairment
    %calculate variance of noise for AWGN given wanted EbNo
    Eb=mean(y.^2)/fb;
    No=Eb/(10^(EbNo/10));
    varn=No*(Fs/2);    
    %create the noise
    noise = normrnd(0,sqrt(varn),numel(y),1);
    %add noise to the signal
    y=y+noise;
    %%%

%     hap.step(real(y));
    y=har.step();
    
    %down
    rawt=hPFOd.step(real(y));
    rawt=LP_FIR.step(complex(rawt))*8;

    %coarse freq estimate and correction if needed
    fftbuffer(fftbufferblkptr*SamplesPerSymbol*numberofsymbolstoxferpercycle+1:fftbufferblkptr*SamplesPerSymbol*numberofsymbolstoxferpercycle+SamplesPerSymbol*numberofsymbolstoxferpercycle)=rawt.^2;
    fftbufferblkptr=fftbufferblkptr+1;fftbufferblkptr=mod(fftbufferblkptr,fftbufferblkcnt);
    if(~fftbufferblkptr)
        %find peaks
        tmp=fftshift(fft(fftbuffer));
        hzperbin=(Fs)/(numel(tmp));
        [~,locs] = findpeaks(abs(tmp),'NPeaks',2,'SortStr','descend','MinPeakDistance',round(((symbolrate/2)/hzperbin)/2));
        if numel(locs)==2
            freq_coarse_offset_est_hz=(mean(locs)-numel(tmp)/2-1)*hzperbin/2;
            freq_diff_est_hz=hzperbin*abs(locs(2)-locs(1))/2;
            freq_spacing_error_hz=abs(freq_diff_est_hz-(symbolrate/2));
            %correct freq if needed
            if(freq_spacing_error_hz<5)%probably the right peaks
                if(abs(freq_coarse_offset_est_hz)>2.0)%fine freq tracking probably cant lock so use course freq estimate instead
                    hPFOd.FrequencyOffset=hPFOd.FrequencyOffset-freq_coarse_offset_est_hz+0.1;
                    fprintf('\nCoarse freq adj..!!!!!! New freq = %gHz\n',hPFOd.FrequencyOffset);
                    hSymTracker.Phase=0;
                    hSymTracker.Freq=0;
                end
            end
        end
    end
    
    %filter
    sig2=MatchFir.step(complex(rawt))*AGCAmp;
    
    %AGC
    AGCMASum=AGCMASum-AGCMABuffer(AGCMAPtr);
    AGCMASum=AGCMASum+mean(abs(sig2));
    AGCMABuffer(AGCMAPtr)=mean(abs(sig2));
    AGCMAPtr=AGCMAPtr+1;
    AGCMAPtr=mod(AGCMAPtr-1,AGCMASz)+1;
    AGCVal=sqrt(2)/max(AGCMASum/AGCMASz,0.000001);
    AGCVal=max(AGCVal,0.000001);
    sig2=sig2*AGCVal;

    %clipping
    aidx=find(abs(sig2)>2.83);
    sig2(aidx)=2.83*sig2(aidx)./abs(sig2(aidx));
    


%Find rotaion that makes real have symbol oscillation and get phase of
%this symbol oscillation
rotationest=0;
bigestval=-1;
%as long as numberofsymbolstoxferpercycle is even the peak falls on a bin
expectedhalfsymbolratepeakloc=numberofsymbolstoxferpercycle/2+1;%hzperbin=(Fs)/(numel(tmp)).   (symbolrate/2)/hzperbin + one cos of matlabs one indexing rather than zero indexing. (symbolrate/2)*numel(tmp)/Fs+1==numberofsymbolstoxferpercycle*(symbolrate*SamplesPerSymbol/Fs)/2+1==numberofsymbolstoxferpercycle/2+1
N=numel(sig2);
n=[0:N-1]';
for rkl=0:1:89
    testsig=(real((sig2*exp(1i*rkl*pi/180)).^2));%rotate square and take real
    val=sum(testsig.*exp(-1i*2*pi*n*(expectedhalfsymbolratepeakloc-1)/N));%1bin DFT 
    aval=abs(val);
    if aval>bigestval
       bigestval=aval;
       rotationest=rkl;
       symboltimginphaseest=angle(val);
    end
end

%%%T/2 symbol tracking on real oscilations and reduction of carrier ambiguity
symerrordiff1=angle(exp(1i*symboltimginphaseest)*exp(-1i*hSymTracker.Phase));
symerrordiff2=angle(exp(1i*(symboltimginphaseest+pi))*exp(-1i*hSymTracker.Phase));
symerrordiff=symerrordiff1;
if(abs(symerrordiff2)<abs(symerrordiff1))
    symerrordiff=symerrordiff2;
    rotationest=rotationest+90;%reduction of carrier ambiguity
end
hSymTracker.Phase=hSymTracker.Phase+hSymTracker.Freq;
hSymTracker.Phase=hSymTracker.Phase+symerrordiff*0.333;
hSymTracker.Freq=hSymTracker.Freq+0.001*symerrordiff;
if abs(hSymTracker.Freq)>(0.1)
    hSymTracker.Freq=(0.1)*sign(hSymTracker.Freq);
end
hSymTracker.Phase=mod(hSymTracker.Phase+pi,2*pi)-pi;
%%%

%%%Carrier tracking
carriererror=(pi/180)*(rotationest-90);
%phase adjustment for next time
hPFOd.PhaseOffset=hPFOd.PhaseOffset+(180/pi)*carriererror*cos(carriererror)*0.7;
hPFOd.PhaseOffset=mod(hPFOd.PhaseOffset,360);
%adjust carrier frequency for next time
hPFOd.FrequencyOffset=hPFOd.FrequencyOffset+0.5*0.90*(180/pi)*(1-cos(carriererror))*carriererror/(360*numberofsymbolstoxferpercycle*SamplesPerSymbol/Fs);
if abs(-hPFOd.FrequencyOffset-hPFOu.FrequencyOffset)>(MaxFreqDeviationLock)
    hPFOd.FrequencyOffset=-hPFOu.FrequencyOffset-(MaxFreqDeviationLock)*sign(-hPFOd.FrequencyOffset-hPFOu.FrequencyOffset);
end
%%%


%%%conversion from OQPSK to QPSK form
fsig2=sig2*exp(1i*carriererror*1);%*exp(1i*carriererror);%correct carrier phase this time. adds jitter but removes any bias in rotaion. not sure if this is good or not
sig2d=SymbolTimingDelay.step(complex(fsig2),SamplesPerSymbol);
sig=(complex(real(fsig2),imag(sig2d)))*0.75;
%%%

%buffer so we can have 2*SamplesPerSymbol from last time
sig=hbuff.step(complex(sig));

hConstellationScopeSymbolPhase.step([exp(1i*symboltimginphaseest);0.7*exp(1i*hSymTracker.Phase)]);
hConstellationScopeCarrierPhase.step(complex(exp(1i*carriererror)));
% hConstellationScopePoints.step(complex(sig));
% hConstellationScopePoints.step(complex(fsig2));


%create sample index
symboltimingstartest=SamplesPerSymbol-SamplesPerSymbol*(hSymTracker.Phase)/pi+1;
tixd=round([symboltimingstartest:2*SamplesPerSymbol:numel(sig)]');
tixd(tixd<1)=[];

%make sure we dont miss any points due to jitter
while (tixd(1)-lastindex)<SamplesPerSymbol
    tixd(1)=[];
end
lastindex=tixd(end)-numel(sig2);

%load on and off points
onpts=sig(tixd);
offpts=sig(mod(tixd-1+SamplesPerSymbol,numel(sig))+1);

%display
tonpts=onpts;tonpts(numel(onpts):(1+numberofsymbolstoxferpercycle/2))=nan;
if sum(~isnan(tonpts))
    hConstellationScopePoints.step(complex(tonpts));
end



%decode data. have to do one at a time as number of points are not fixed
%each block
for jop=1:numel(tixd)
    thisonpt=onpts(jop);

    im=1-hdiffdec.step(imag(thisonpt)>0);
    re=hdiffdec.step(real(thisonpt)>0);
    fprintf(vari_decode((im>0)));
    fprintf(vari_decode((re>0)));
    
end






end







